import { ActionRowBuilder, ButtonBuilder, ButtonInteraction, ButtonStyle, CommandInteraction, EmbedBuilder } from "discord.js";

export default class EmbedPage extends EmbedBuilder {
    private row: ActionRowBuilder<ButtonBuilder>;

    constructor(embedId: string, page: number, total: number) {
        super();

        this.setFooter({ text: `Page ${page + 1} of ${total + 1}`});

        this.row = new ActionRowBuilder<ButtonBuilder>();

        this.row.addComponents(
            new ButtonBuilder()
                .setCustomId(`pagination ${embedId} previous`)
                .setLabel("◀️")
                .setStyle(ButtonStyle.Primary)
                .setDisabled(page == 0),
            new ButtonBuilder()
                .setCustomId(`pagination ${embedId} next`)
                .setLabel("▶️")
                .setStyle(ButtonStyle.Primary)
                .setDisabled(page == total));
    }

    public async sendCommandEmbed(interaction: CommandInteraction) {
        await interaction.reply({
            embeds: [ this ],
            components: [ this.row ],
        });
    }

    public async sendButtonEmbed(interaction: ButtonInteraction) {
        await interaction.update({
            embeds: [ this ],
            components: [ this.row ],
        });
        return;
    }
}