import { ButtonInteraction, CacheType } from "discord.js";
import { Command } from "./command";
import PaginatedEmbed from "../helpers/PaginatedEmbed";
import EmbedPage from "./embedPage";

export class PaginatedCommand<TPage extends EmbedPage> extends Command {
    public CommandBuilder: any;
    public paginatedEmbed: PaginatedEmbed<TPage>;

    constructor() {
        super();

        this.paginatedEmbed = new PaginatedEmbed<TPage>("paginationtest");
    }

    public async nextPage(interaction: ButtonInteraction<CacheType>) {
        const page = this.paginatedEmbed.NextPage();

        await page!.sendButtonEmbed(interaction);
    }

    public async previousPage(interaction: ButtonInteraction<CacheType>) {
        const page = this.paginatedEmbed.PreviousPage();

        await page!.sendButtonEmbed(interaction);
    }
}
